/* application.js contains general helper classes and funtions for settings, */
/* progressbars and HTTPRequest wrapping */

/* TODO:s
	Add function for browser-independent attach event : application_attachEvent(element, eventName); Bubble param?
*/

/* The application object is supposed to hold application-wide settings*/
function application(Title)
{
	this.Title = Title;
	this.makeprogress = function makeprogress(count, total, caption) {application_makeprogress(this,count,total,caption);}
	this.progressimage = null;
	this.progresscaption = null;
	this.fulltextview = function fulltextview(caption) {application_fulltextview(this,caption);}
	this.errorcolor = "#FFAAAA";
	this.IEOKcolor = "#FFFFFF"; // Necessary since i haven't found a way to change back to the old style in IE. 
	
	this.editors = new Array();
	
	this.add_editor = function add_editor(element, datatype, onEdit, onError)
	{
		new editor_object(this, element, datatype, onEdit, onError);
		return element;
	}


}


function application_makeprogress(appobj,count,total,caption)
{


}
function application_fulltextview(appobj,caption)
{
  document.title = appobj.Title + " - " + caption ;
}

function setErrorBackground(val_result, app_obj, event_object)
{
	if (val_result)
	{
		event_object.target.style.backgroundColor = app_obj.errorcolor;
	}
	else
	{
		// Small hack to get back to old color.
	    var tmp_classname = event_object.target.className;
	    if (event_object.target.style.removeProperty)
	    {
		    event_object.target.className = "";
			event_object.target.style.removeProperty("background-color");
			event_object.target.className = tmp_classname;
		}
		else
		{
			if (app_obj.IEOKcolor)
			{
				event_object.target.style.backgroundColor = app_obj.IEOKcolor;
			}
			else
			{
				alert("Sorry, resetting the error-color doesn't work in IE due to the lack of the style.remove/setProperty function which is currently used, \runless you set the application.IEOKcolor property.");
			}
		}
	}

}



// The editor object class holds the settings for input handling of a certain input/select element.
// This is used when creating standalone input elements.
function editor_object(app_obj, element, datatype, onEdit, onError)
{
	this.element = element;
	this.app_obj = app_obj;
	this.datatype = datatype; 
	this.onEdit = onEdit;
	this.onError = onError;
	var parentobj = this; // Declaration for the functions...JavaScript duh..
	app_obj.editors.push(this);
	
	this.DoOnEdit = function DoOnEdit(e)
	{
		var event_object = new edit_event_object(e);
		if (event_object.key)
		{
			var val_result = validate_datatype(event_object.value, parentobj.datatype);
			setErrorBackground(val_result, parentobj.app_obj, event_object);
			if (val_result)
			{
				if (onError)
				{
					onError(this.element, val_result);
				}
			}
			else
			{
				if (onEdit)
				{
					onEdit(this.element);
				}
			}
		}
	}
	
	// Edit event
	if (element.attachEvent) 
	{
		element.attachEvent("onkeyup", this.DoOnEdit);
	}
	else
	{
		element.addEventListener("keyup", this.DoOnEdit, false); // standards compliant; doesn't work in IE
	}

}


//Helper functions

function MakeParagraph(a_value, a_class)
{
	return '<p class="' + a_class + '">' + a_value + '</p>';
}
function MakeSpanned(a_value, a_class)
{
	return '<span class="' + a_class + '">' + a_value + '</span>';
}

// Get an XMLHttpRequest object in a portable way. -- Snitched from www.boutell.com
function newRequest()
{
  var req;
  req = false;
  // For Safari, Firefox, and other non-MS browsers
  if (window.XMLHttpRequest) {
    try {
      req = new XMLHttpRequest();
    } catch (e) {
      req = false;
    }
  } else if (window.ActiveXObject) {
    // For Internet Explorer on Windows
    try {
      req = new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
      try {
        req = new ActiveXObject("Microsoft.XMLHTTP");
      } catch (e) {
        req = false;
      }
    }
  }
  return req;
}


function MakeRequest(URL, method, query)
{	

  var req = newRequest();
	if (method)
	{
		req.open(method, URL, false);
	  
		if (method == "POST")
		{
			req.setRequestHeader('Content-Type',
			'application/x-www-form-urlencoded');
		}
	}
	else
	{
		req.open("GET", URL, false);
		
	}


	if (query)
	{
	  req.send(Query);
	}
	else
	{
		req.send("");
	}

	return req.responseText;

}

function add_tr_to_table(table, element, old)
{
	if (old)
	{
		//var new_tbody = document.createElement("tbody");
		//new_tbody.appendChild(element);
		old.parentNode.insertBefore(element, old);

	}
	else
	{
		if (table.tBodies.length == 1)
		{
		
			table.tBodies[0].appendChild(element);
		}
		else
		{
			var new_tbody = document.createElement("tbody");
			new_tbody.appendChild(element);
			table.appendChild(new_tbody);
			
		}
	}

}



function invert_element(obj)
{

  if (obj.currentStyle)
  {
		var tmpclr = obj.currentStyle.backgroundColor;
		obj.style.backgroundColor = obj.currentStyle.color;
	}
	else
	{
		var tmpclr = document.defaultView.getComputedStyle(obj, null).getPropertyValue("background-color");
		obj.style.backgroundColor = document.defaultView.getComputedStyle(obj, null).getPropertyValue("color");
	}
	obj.style.color = tmpclr;
}








